<?php 
/**
 * @version 1.0
 * @copyright Copyright (C) 2014 rayzzz.com. All rights reserved.
 * @license GNU/GPL2, see LICENSE.txt
 * @website http://rayzzz.com
 * @twitter @rayzzzcom
 * @email rayzexpert@gmail.com
 */
require_once('../../config.php');

class rz_integration extends rz_base
{
	var $DB_PREFIX;
	var $sSiteUrl;
	var $sLoginUrl;
	
    function rz_integration($sPath, $sUrl){
		parent::__construct($sPath, $sUrl);
		global $db_host, $db_name, $db_user, $db_pass;
		$this->oDb = new RzDbConnect($db_host, '', '', $db_name, $db_user, $db_pass);
		$this->oDb->connect();
		$this->DB_PREFIX = DB_PREFIX;
		
		$aUrl = explode("infusions/", $this->sUrl);
		$this->sLoginUrl = $this->sSiteUrl = $aUrl[0];
    }
	
	function _loginUser($sName, $sPassword, $bLogin = false){
		$sField = $bLogin ? "user_name" : "user_id";
		$sId = $this->oDb->getValue("SELECT `user_id` FROM `" . $this->DB_PREFIX . "users` WHERE `" . $sField . "`='" . $sName . "' AND `user_password`='" . $sPassword . "' LIMIT 1");
		return !empty($sId);
	}
	
	function _loginAdmin($sId, $sPassword){
		$sId = $this->oDb->getValue("SELECT `user_id` FROM `" . $this->DB_PREFIX . "users` WHERE `user_id`='" . $sId . "' AND `user_password`='" . $sPassword . "' AND `user_admin_password`!='' LIMIT 1");
		return !empty($sId);
	}
	
	function _getUserInfo($sId, $bNick = false){
		$sWherePart = ($bNick ? "`user_name`" : "`user_id`") . " = '" . $sId . "'";
		$aUser = $this->oDb->getArray("SELECT *, YEAR(FROM_DAYS(DATEDIFF(NOW(), `user_birthdate`))) AS `user_age` FROM `" . $this->DB_PREFIX . "users` WHERE " . $sWherePart . " LIMIT 1");

		$sSex = "male";
		$sNick = $aUser['user_name'];
		$sAge = $aUser['user_age'];
		$sDesc = $aUser['user_sig'];;
		$sProfile = $this->sSiteUrl . "profile.php?lookup=" . $aUser["user_id"];
		
		if(!empty($aUser['user_avatar']))
			$sPhoto = $this->sSiteUrl . "images/avatars/" . $aUser['user_avatar'];
		else
			$sPhoto = $this->sUrl . "data/" . ($sSex == "male" ? "male.jpg" : "female.jpg");
		
		return array("id" => (int)$aUser["user_id"], "nick" => $sNick, "sex" => $sSex, "age" => $sAge, "desc" => $sDesc, "photo" => $sPhoto, "profile" => $sProfile);
	}
	
	function _searchUser($sValue, $sField = "ID"){
		if($sField == "ID")
		   $sField = "user_id";
		else
		   $sField = "user_name";

		$sId = $this->oDb->getValue("SELECT `user_id` FROM `" . $this->DB_PREFIX . "users` WHERE `" . $sField . "` = '" . $sValue . "' LIMIT 1");
		return $sId;
	}
	
	function _getCurrentLang($sUserId = ""){
		$sLang = $this->oDb->getValue("SELECT `settings_value` FROM `" . $this->DB_PREFIX . "settings` WHERE `settings_name` = 'locale' LIMIT 1");
		if(!empty($sLang))
			return substr(strtolower($sLang), 0, 2);
		return parent::_getCurrentLang($sUserId);
	}

	function _getMembershipId($sUserId){
		$sGroups = $this->oDb->getValue("SELECT `user_groups` FROM `" . $this->DB_PREFIX . "users` WHERE `user_id` = '" . $sUserId . "' LIMIT 1");
		if(empty($sGroups))
			return 0;
		$sGroups = substr($sGroups, 1);
		$aGroups = explode('.', $sGroups);
		return (int)$aGroups[0];
	}

	function _getMemberships(){
		$aGroups = array();
		$aGroups[0] = 'Without Group';
		$rRes = $this->oDb->getResult("SELECT * FROM `" . $this->DB_PREFIX . "user_groups`");
		for($i=0; $i<mysql_num_rows($rRes); $i++)
		{
			$aGroup = mysql_fetch_assoc($rRes);
			$aGroups[$aGroup['group_id']] = $aGroup['group_name'];
		}
		return $aGroups;
	}
	
	function _getUserPrefer($sId)
	{
		return 'b';
	}
}
