<?php 
/**
 * @version 1.0
 * @copyright Copyright (C) 2014 rayzzz.com. All rights reserved.
 * @license GNU/GPL2, see LICENSE.txt
 * @website http://rayzzz.com
 * @twitter @rayzzzcom
 * @email rayzexpert@gmail.com
 */
class rz_module extends rz_integration
{
	var $sModule = "rzroulette";
	var $USERS_DB_TABLE;
	
    function rz_module($sPath, $sUrl)
    {
		parent::__construct($sPath, $sUrl);
		$this->USERS_DB_TABLE = $this->DB_PREFIX . $this->sModule . "_users";
		
		$this->aXmlTemplates["result"][3] = '<result user="#1#" connect="#2#" status="#3#" />';
		$this->aXmlTemplates["result"][4] = '<result value="#1#" status="#2#" gender="#3#" prefer="#4#" />';
		$this->aXmlTemplates["update"] = array (
			3 => '<update count="#1#" current="#2#" status="#3#" />'
		);
    }

    function actionUserAuthorize(){
		$sPassword = $this->_getRequestVar("password");
        if(!$this->_loginUser($this->sId, $sPassword))
			$this->sId = time();
        return $this->_parseXml($this->aXmlTemplates['result'], $this->sId, $this->SUCCESS_VAL, $this->_getUserGender($this->sId), $this->_getUserPrefer($this->sId));
    }
	
	function actionAdminAuthorize(){
		$sPassword = $this->_getRequestVar("password");
        if(!$this->_loginAdmin($this->sId, $sPassword))
			return $this->_parseXml($this->aXmlTemplates['result'], "Authorization Failed", $this->FAILED_VAL);
        return $this->actionUserAuthorize();
    }
	
	function actionSetGender(){
		$sGender = $this->_getRequestVar("gender");
		if($sGender != 'm' && $sGender != 'f')
			$sGender = 'm';
        $this->oDb->getResult("UPDATE `" . $this->USERS_DB_TABLE . "` SET `Gender`='" . $sGender . "', `When`=" . time() . " WHERE `User`='" . $this->sId . "' LIMIT 1");
        return $this->_parseXml($this->aXmlTemplates['result'], "", $this->SUCCESS_VAL);
	}
	
	function actionSetPrefer(){
		$sPrefer = $this->_getRequestVar("prefer");
		if($sPrefer != 'm' && $sPrefer != 'f' && $sPrefer != 'b')
			$sPrefer = 'b';
        $this->oDb->getResult("UPDATE `" . $this->USERS_DB_TABLE . "` SET `Prefer`='" . $sPrefer . "', `When`=" . time() . " WHERE `User`='" . $this->sId . "' LIMIT 1");
        return $this->_parseXml($this->aXmlTemplates['result'], "", $this->SUCCESS_VAL);
	}

	function actionConnect(){
		$sGender = $this->_getRequestVar("gender");
		if($sGender != 'm' && $sGender != 'f')
			$sGender = 'm';
		$sPrefer = $this->_getRequestVar("prefer");
		if($sPrefer != 'm' && $sPrefer != 'f' && $sPrefer != 'b')
			$sPrefer = 'b';
		$sConnect = $this->_getRequestVar("connect");
        $this->_connectUser($this->sId, $sConnect, $sGender, $sPrefer);
        return $this->_parseXml($this->aXmlTemplates['result'], "", $this->SUCCESS_VAL);
    }
	
	function actionDisconnect(){
        $this->_disconnectUser($this->sId);
        return $this->_parseXml($this->aXmlTemplates['result'], "", $this->SUCCESS_VAL);
    }
	
    function actionFindNext(){
		$aResult = $this->_findNext($this->sId);
		if(count($aResult) > 0)
			return $this->_parseXml($this->aXmlTemplates['result'], $aResult['user'], $aResult['connect'], $this->SUCCESS_VAL);
		else
			return $this->_parseXml($this->aXmlTemplates['result'], "", $this->FAILED_VAL);
	}
	
	function actionFindCurrent(){
		$aResult = $this->_findCurrent($this->sId);
		if(count($aResult) > 0)
			return $this->_parseXml($this->aXmlTemplates['result'], $aResult['user'], $aResult['connect'], $this->SUCCESS_VAL);
		else
			return $this->_parseXml($this->aXmlTemplates['result'], "", $this->FAILED_VAL);
	}
	
	function actionUpdate(){
		$aResult = $this->_refreshUser($this->sId);
		return $this->_parseXml($this->aXmlTemplates['update'], $aResult['count'], $aResult['current'], $this->SUCCESS_VAL);
	}

	function _findNext($sUserId)
	{
		list($sId, $sCurrentId) = $this->_getUserDetails($sUserId);
		if(!empty($sCurrentId))
			$this->oDb->getResult("UPDATE `" . $this->USERS_DB_TABLE . "` SET `Current`='' WHERE `ID`=" . $sCurrentId);
		$sWatched = $this->_getWatched($sId);
		$sWatchedFactor = empty($sWatched) ? "" : " AND `ID` NOT IN (" . $sWatched . ")";
		$aNext = $this->oDb->getArray("SELECT * FROM `" . $this->USERS_DB_TABLE . "` WHERE `User`!='" . $sUserId . "' AND `Current`=''" . $sWatchedFactor . $this->_getGenderFactor($sId) . " LIMIT 1");
		if(is_array($aNext) && count($aNext)>1)
		{
			$sWatched = empty($sWatched) ? $aNext['ID'] : $sWatched . "," . $aNext['ID'];
			$this->oDb->getResult("UPDATE `" . $this->USERS_DB_TABLE . "` SET `Watched`='" . $sWatched . "', `Current`='" . $aNext['ID'] . "' WHERE `User`='" . $sUserId . "' LIMIT 1");
			$sWatched = $this->_getWatched($aNext['ID']);
			$sWatched = empty($sWatched) ? $sId : $sWatched . "," . $sId;
			$this->oDb->getResult("UPDATE `" . $this->USERS_DB_TABLE . "` SET `Watched`='" . $sWatched . "', `Current`='" . $sId . "' WHERE `ID`='" . $aNext['ID'] . "' LIMIT 1");
			return array('user'=>$aNext['User'], 'connect'=>$aNext['Connect']);
		}
		else if(!empty($sWatchedFactor))
		{
			$this->oDb->getResult("UPDATE `" . $this->USERS_DB_TABLE . "` SET `Watched`='' WHERE `ID`='" . $sId . "'");
			return $this->_findNext($sUserId);
		}
		return array();
	}

	function _getGenderFactor($sUserId)
	{
		$aUser = $this->oDb->getArray("SELECT * FROM `" . $this->USERS_DB_TABLE . "` WHERE `ID`='" . $sUserId . "'");
		$sFactor = " AND `Prefer` IN ('b','" . $aUser['Gender'] . "')";
		if($aUser['Prefer'] == 'm')
			$sFactor .= " AND `Gender`='m'";
		elseif($aUser['Prefer'] == 'f')
			$sFactor .= " AND `Gender`='f'";
		return $sFactor;
	}

	function _findCurrent($sUserId)
	{
		$iCurrent = (int)$this->oDb->getValue("SELECT `Current` FROM `" . $this->USERS_DB_TABLE . "` WHERE `User`='" . $sUserId . "' LIMIT 1");
		if($iCurrent > 0)
		{
			$aCurrent = $this->oDb->getArray("SELECT * FROM `" . $this->USERS_DB_TABLE . "` WHERE `ID`=" . $iCurrent);
			if(is_array($aCurrent) && count($aCurrent)>1)
				return array('user'=>$aCurrent['User'], 'connect'=>$aCurrent['Connect']);
		}
		return array();
	}

	function _getUserDetails($sUserId)
	{
		return $this->oDb->getArray("SELECT `ID`, `Current` FROM `" . $this->USERS_DB_TABLE . "` WHERE `User`='" . $sUserId . "' LIMIT 1");
	}

	function _getWatched($sId)
	{
		return $this->oDb->getValue("SELECT `Watched` FROM `" . $this->USERS_DB_TABLE . "` WHERE `ID`='" . $sId . "' LIMIT 1");
	}

	function _refreshUser($sUserId)
	{
		$iUpdateInterval = (int)$this->_getSettingValue("updateInterval");
		$iIdleTime = $iUpdateInterval * 3;

		$iCurrentTime = time();
		
		list($sId, $sCurrentId) = $this->_getUserDetails($sUserId);
		$bCurrent = !empty($sCurrentId);
		
		$this->oDb->getResult("UPDATE `" . $this->USERS_DB_TABLE . "` SET `When`=" . $iCurrentTime . " WHERE `User`='" . $sUserId . "' LIMIT 1");
		$rRes = $this->oDb->getResult("SELECT `ID` FROM `" . $this->USERS_DB_TABLE . "` WHERE (" . $iCurrentTime . "-`When`)>" . $iIdleTime);
		while(($aUser=mysql_fetch_assoc($rRes)) != null)
		{
			$this->oDb->getResult("UPDATE `" . $this->USERS_DB_TABLE . "` SET `Current`='' WHERE `Current`=" . $aUser['ID']);
			if($aUser['ID'] == $sCurrentId)
				$bCurrent = false;
		}
		$this->oDb->getResult("DELETE FROM `" . $this->USERS_DB_TABLE . "` WHERE (" . $iCurrentTime . "-`When`)>" . $iIdleTime);
			
		return array('count'=>(int)$this->oDb->getValue("SELECT COUNT(`ID`) FROM `" . $this->USERS_DB_TABLE . "`"), 'current'=>($bCurrent ? $this->TRUE_VAL : $this->FALSE_VAL));
	}

	function _connectUser($sUserId, $sConnect, $sGender, $sPrefer)
	{
		$this->_disconnectUser($sUserId);
		$this->oDb->getResult("INSERT INTO `" . $this->USERS_DB_TABLE . "`(`User`, `Gender`, `Prefer`, `Connect`, `When`) VALUES('" . $sUserId . "', '" . $sGender . "', '" . $sPrefer . "', '" . $sConnect . "', " . time() . ")");
	}

	function _disconnectUser($sUserId)
	{
		list($sId, $sCurrentId) = $this->_getUserDetails($sUserId);
		$this->oDb->getResult("UPDATE `" . $this->USERS_DB_TABLE . "` SET `Current`='' WHERE `ID`='" . $sCurrentId . "'");
		$this->oDb->getResult("DELETE FROM `" . $this->USERS_DB_TABLE . "` WHERE `ID`='" . $sId . "'");
	}
	
	function _getUserGender($sId)
	{
		$aUser = $this->_getUserInfo($sId);
		if(empty($aUser['sex']))
			return 'm';
		return $aUser['sex'] == 'male' ? 'm' : 'f';
	}
}
